{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#align.cwl",
            "baseCommand": [
                "chmod"
            ],
            "inputs": [
                {
                    "id": "#align.cwl/marko_zecevic_topmed_alignment_topmed_align_0/reference",
                    "type": "File",
                    "https://sevenbridges.comcategory": "Input files"
                },
                {
                    "id": "#align.cwl/marko_zecevic_topmed_alignment_topmed_align_0/fastq",
                    "type": "File",
                    "inputBinding": {
                        "position": 8,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#align.cwl/marko_zecevic_topmed_alignment_topmed_align_0/list",
                    "type": "File",
                    "inputBinding": {
                        "position": 9,
                        "shellQuote": false
                    },
                    "https://sevenbridges.comcategory": "Input files"
                },
                {
                    "id": "#align.cwl/marko_zecevic_topmed_alignment_topmed_align_0/ram_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum amount of RAM",
                    "default": 14000,
                    "https://sevenbridges.comtoolDefaultValue": "14000"
                },
                {
                    "id": "#align.cwl/marko_zecevic_topmed_alignment_topmed_align_0/cores_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum number of cores",
                    "default": 8,
                    "https://sevenbridges.comtoolDefaultValue": "8"
                }
            ],
            "label": "Align 1.0",
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "+x"
                },
                {
                    "position": 2,
                    "shellQuote": false,
                    "valueFrom": "align.sh"
                },
                {
                    "position": 3,
                    "shellQuote": false,
                    "valueFrom": "&&"
                },
                {
                    "position": 4,
                    "shellQuote": false,
                    "valueFrom": "tar"
                },
                {
                    "position": 5,
                    "shellQuote": false,
                    "valueFrom": "-xf"
                },
                {
                    "position": 6,
                    "shellQuote": false,
                    "valueFrom": "&& ./align.sh"
                },
                {
                    "position": 5,
                    "shellQuote": false,
                    "valueFrom": "${\n    return inputs.reference.path\n}"
                },
                {
                    "position": 7,
                    "shellQuote": false,
                    "valueFrom": "${\n    var reference_file = inputs.reference.path.split('/')[inputs.reference.path.split('/').length - 1]\n    var name = reference_file.slice(0, -4) // cut .tar extension     \n    return name\n}"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": "$(inputs.ram_min)",
                    "coresMin": "$(inputs.cores_min)"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "statgen/alignment:1.0.0"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "align.sh",
                            "entry": "${\n var s = '#!/bin/bash\\n'\n\n s += 'ref_path=$1\\n'\n s += 'input_path=$2\\n'\n s += 'list=$3\\n'\n\n s += 'line=$(grep $(basename $input_path) < $list)\\n'\n\n s += 'line_rg=$(echo $line | cut -d \\' \\' -f 4- | sed -e \\\"s\\/ \\/\\\\\\\\\\\\t\\/g\\\")\\n'\n s += 'input_filename=$(basename $input_path)\\n'\n s += 'output_filename=$(basename $input_filename \\\".fastq.gz\\\").cram\\n'\n\n s += 'paired_flag=\\\"\\\"\\n'\n s += 'if [[ $input_filename =~ interleaved\\\\.fastq\\\\.gz$ ]]\\n'\n s += 'then\\n'\n s += '\\tpaired_flag=\\\"-p\\\"\\n'\n s += 'fi\\n'\n\n s += 'bwa mem -t 32 -K 100000000 -Y ${paired_flag} -R \\\"$line_rg\\\" $ref_path $input_path | samblaster -a --addMateTags | samtools view -@ 32 -T $ref_path -C -o $output_filename -\\n'\n \nreturn s\n}"
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var updateMetadata = function(file, key, value) {\n    file['metadata'][key] = value;\n    return file;\n};\n\n\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file))\n        file['metadata'] = metadata;\n    else {\n        for (var key in metadata) {\n            file['metadata'][key] = metadata[key];\n        }\n    }\n    return file\n};\n\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n        }\n    }\n    return o1;\n};\n\nvar toArray = function(file) {\n    return [].concat(file);\n};\n\nvar groupBy = function(files, key) {\n    var groupedFiles = [];\n    var tempDict = {};\n    for (var i = 0; i < files.length; i++) {\n        var value = files[i]['metadata'][key];\n        if (value in tempDict)\n            tempDict[value].push(files[i]);\n        else tempDict[value] = [files[i]];\n    }\n    for (var key in tempDict) {\n        groupedFiles.push(tempDict[key]);\n    }\n    return groupedFiles;\n};\n\nvar orderBy = function(files, key, order) {\n    var compareFunction = function(a, b) {\n        if (a['metadata'][key].constructor === Number) {\n            return a['metadata'][key] - b['metadata'][key];\n        } else {\n            var nameA = a['metadata'][key].toUpperCase();\n            var nameB = b['metadata'][key].toUpperCase();\n            if (nameA < nameB) {\n                return -1;\n            }\n            if (nameA > nameB) {\n                return 1;\n            }\n            return 0;\n        }\n    };\n\n    files = files.sort(compareFunction);\n    if (order == undefined || order == \"asc\")\n        return files;\n    else\n        return files.reverse();\n};"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comAWSInstanceType",
                    "value": "c5.4xlarge;ebs-gp2;512"
                }
            ],
            "outputs": [
                {
                    "id": "#align.cwl/marko_zecevic_topmed_alignment_topmed_align_0/cram",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.cram",
                        "outputEval": "${\n    return inheritMetadata(self, inputs.fastq)\n\n}"
                    },
                    "format": "#align.cwl/marko_zecevic_topmed_alignment_topmed_align_0/CRAM"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#alignment-validation.cwl",
            "baseCommand": [
                "{",
                "samtools",
                "view"
            ],
            "inputs": [
                {
                    "id": "#alignment-validation.cwl/alignment_validation/cram",
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "shellQuote": false
                    },
                    "label": "Alignment file",
                    "doc": "Input CRAM file",
                    "https://sevenbridges.comcategory": "Input files",
                    "https://sevenbridges.comfileTypes": "CRAM"
                },
                {
                    "id": "#alignment-validation.cwl/alignment_validation/expected_md5",
                    "type": "string",
                    "inputBinding": {
                        "position": 9,
                        "shellQuote": false
                    },
                    "label": "MD5",
                    "doc": "Expected MD5 hash.",
                    "https://sevenbridges.comcategory": "Parameters"
                },
                {
                    "id": "#alignment-validation.cwl/alignment_validation/reference",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--reference"
                    },
                    "label": "Reference",
                    "doc": "Reference genome sequence.",
                    "https://sevenbridges.comcategory": "Input files",
                    "https://sevenbridges.comfileTypes": "FASTA, FA"
                },
                {
                    "id": "#alignment-validation.cwl/alignment_validation/ram_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum amount of RAM",
                    "default": 2000,
                    "https://sevenbridges.comtoolDefaultValue": "7500"
                },
                {
                    "id": "#alignment-validation.cwl/alignment_validation/cores_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum number of cores",
                    "default": 1,
                    "https://sevenbridges.comtoolDefaultValue": "8"
                }
            ],
            "outputs": [
                {
                    "id": "#alignment-validation.cwl/alignment_validation/stdout",
                    "label": "stdout",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "log.stdout"
                    }
                },
                {
                    "id": "#alignment-validation.cwl/alignment_validation/stderr",
                    "label": "stderr",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "log.stderr"
                    }
                }
            ],
            "label": "Validation",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "",
                    "shellQuote": false,
                    "valueFrom": "${\n    var input_filename = inputs.cram.path.split('/').pop()\n    var input_name_base = input_filename.split('.').slice(0,-1).join('.')\n    var aux = \"--output-fmt SAM -o \" + input_name_base + \".sam\"\n    return aux\n}\n"
                },
                {
                    "position": 4,
                    "prefix": "",
                    "shellQuote": false,
                    "valueFrom": "${\n    var ret = \"&& md5=$(md5sum \"\n    var input_filename = inputs.cram.path.split('/').pop()\n    var input_name_base = input_filename.split('.').slice(0,-1).join('.')\n    return ret + input_name_base + \".sam | awk '{ print $1 }') && if [ $md5 = \" \n}"
                },
                {
                    "position": 11,
                    "prefix": "",
                    "separate": false,
                    "shellQuote": false,
                    "valueFrom": "${\n    return \"]; then exit 0; else exit 1; fi; } >> log.stdout 2> log.stderr\"\n}"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": "$(inputs.ram_min)",
                    "coresMin": "$(inputs.cores_min)"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "statgen/alignment:1.0.0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.cram)",
                        "$(inputs.reference)"
                    ]
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#post-align.cwl",
            "baseCommand": [
                "samtools",
                "merge"
            ],
            "inputs": [
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/reference",
                    "type": "File"
                },
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/dbsnp",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--dbsnp",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/alignment_files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "https://sevenbridges.comfileTypes": "BAM"
                },
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/threads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Number of threads",
                    "default": 1
                },
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/input_cram",
                    "type": "File",
                    "label": "Input CRAM",
                    "doc": "Input CRAM is passed to Post-align for output naming.",
                    "https://sevenbridges.comfileTypes": "CRAM"
                },
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/ram_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum amount of RAM",
                    "default": 7500
                },
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/cores_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum number of cores",
                    "default": 8
                }
            ],
            "outputs": [
                {
                    "id": "#post-align.cwl/marko_zecevic_topmed_alignment_topmed_post_align_3/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  var outname = inputs.input_cram.path.split('/').slice(-1)[0]\n  outname = outname.split('.').slice(0, -1).join('.')\n  outname = outname.concat(\".recab.cram\")\n  return outname\n}"
                    }
                }
            ],
            "label": "Post-align",
            "arguments": [
                {
                    "position": 1,
                    "prefix": "",
                    "shellQuote": false,
                    "valueFrom": "-c merged.bam *.sorted.bam && bam-non-primary-dedup dedup_LowMem --allReadNames --binCustom --binQualS 0:2,3:3,4:4,5:5,6:6,7:10,13:20,23:30 --log dedup_lowmem.metrics --recab --in merged.bam --out -.ubam"
                },
                {
                    "position": 2,
                    "prefix": "--refFile",
                    "shellQuote": false,
                    "valueFrom": "${\n    return inputs.reference.path\n}"
                },
                {
                    "position": 4,
                    "prefix": "",
                    "shellQuote": false,
                    "valueFrom": "| samtools view -h -C"
                },
                {
                    "position": 5,
                    "prefix": "-T",
                    "shellQuote": false,
                    "valueFrom": "${\n    return inputs.reference.path\n}"
                },
                {
                    "position": 6,
                    "prefix": "-o",
                    "shellQuote": false,
                    "valueFrom": "${\n  var outname = inputs.input_cram.path.split('/').slice(-1)[0]\n  outname = outname.split('.').slice(0, -1).join('.')\n  outname = outname.concat(\".recab.cram\")\n  return outname\n}"
                },
                {
                    "position": 0,
                    "prefix": "--threads",
                    "shellQuote": false,
                    "valueFrom": "${\n if (inputs.threads) {\n     return inputs.threads\n } else {\n     return 1\n }\n}"
                },
                {
                    "position": 8,
                    "prefix": "--threads",
                    "shellQuote": false,
                    "valueFrom": "${\n if (inputs.threads) {\n     return inputs.threads\n } else {\n     return 1\n }\n}"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": "$(inputs.ram_min)",
                    "coresMin": "$(inputs.cores_min)"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "statgen/alignment:1.0.0"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": "${ \n    var out = []\n    out.push(inputs.reference)\n    out.push(inputs.input_cram)\n    for (var i = 0; i < inputs.alignment_files.length; i++) { \n        out.push(inputs.alignment_files[i]);\n    }\n    return out\n    \n}"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comAWSInstanceType",
                    "value": "m5.large;ebs-gp2;700"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#pre-align.cwl",
            "baseCommand": [
                "samtools",
                "view"
            ],
            "inputs": [
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/input_file",
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "shellQuote": false
                    },
                    "label": "Input CRAM file",
                    "https://sevenbridges.comfileTypes": "CRAM"
                },
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/decomp_ref",
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "Reference for input CRAM decompressing",
                    "https://sevenbridges.comcategory": "Input file",
                    "https://sevenbridges.comfileTypes": "FASTA, FA"
                },
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/comp_ref",
                    "type": "File",
                    "label": "Reference for output CRAM compressing",
                    "https://sevenbridges.comcategory": "Input file",
                    "https://sevenbridges.comfileTypes": "FASTA, FA"
                },
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/threads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Number of threads",
                    "default": 1,
                    "https://sevenbridges.comtoolDefaultValue": "1"
                },
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/ram_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum amount of RAM",
                    "default": 7500,
                    "https://sevenbridges.comtoolDefaultValue": "7500"
                },
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/cores_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum number of cores",
                    "default": 8,
                    "https://sevenbridges.comtoolDefaultValue": "8"
                }
            ],
            "outputs": [
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/fastq",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputBinding": {
                        "glob": "*.gz",
                        "outputEval": "$(inheritMetadata(self, inputs.input_file))"
                    }
                },
                {
                    "id": "#pre-align.cwl/marko_zecevic_validation_app_topmed_alignment_topmed_pre_align_7/list",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.list",
                        "outputEval": "$(inheritMetadata(self, inputs.input_file))"
                    }
                }
            ],
            "label": "Pre-align 1.0",
            "arguments": [
                {
                    "position": 3,
                    "prefix": "| bam-ext-mem-sort-manager squeeze --in -.ubam --keepDups --rmTags AS:i,BD:Z,BI:Z,XS:i,MC:Z,MD:Z,NM:i,MQ:i --out -.ubam | samtools sort -l 1 -@",
                    "shellQuote": false,
                    "valueFrom": "${\n if (inputs.threads) {\n     return inputs.threads\n } else {\n     return 1\n }\n}"
                },
                {
                    "position": 4,
                    "prefix": "-n -T",
                    "shellQuote": false,
                    "valueFrom": "${\n    return inputs.input_file.nameroot + '.samtools_sort_tmp'\n}"
                },
                {
                    "position": 5,
                    "prefix": "",
                    "shellQuote": false,
                    "valueFrom": "- | samtools fixmate - - | bam-ext-mem-sort-manager bam2fastq --in -.bam"
                },
                {
                    "position": 6,
                    "prefix": "--outBase",
                    "shellQuote": false,
                    "valueFrom": "${\n    return inputs.input_file.nameroot\n}"
                },
                {
                    "position": 7,
                    "prefix": "",
                    "shellQuote": false,
                    "valueFrom": "--maxRecordLimitPerFq 20000000 --sortByReadNameOnTheFly --readname --gzip"
                },
                {
                    "position": 1,
                    "prefix": "-uh -F 0x900 --threads",
                    "shellQuote": false,
                    "valueFrom": "${\n if (inputs.threads) {\n     return inputs.threads\n } else {\n     return 1\n }\n}"
                },
                {
                    "position": 2,
                    "prefix": "-T",
                    "valueFrom": "${\n if (inputs.decomp_ref) {\n     return inputs.decomp_ref.path\n } else {\n     return inputs.comp_ref.path\n }\n}"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": "$(inputs.ram_min)",
                    "coresMin": "$(inputs.cores_min)"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "statgen/alignment:1.0.0"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.comp_ref)"
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file))\n        file['metadata'] = metadata;\n    else {\n        for (var key in metadata) {\n            file['metadata'][key] = metadata[key];\n        }\n    }\n    return file\n};\n\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n        }\n    }\n    return o1;\n};"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comAWSInstanceType",
                    "value": "m5.large;ebs-gp2;512"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#samtools-sort.cwl",
            "baseCommand": [
                "samtools",
                "sort"
            ],
            "inputs": [
                {
                    "id": "#samtools-sort.cwl/marko_zecevic_topmed_alignment_samtools_sort_0/reference",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--reference",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#samtools-sort.cwl/marko_zecevic_topmed_alignment_samtools_sort_0/input_file",
                    "type": "File",
                    "inputBinding": {
                        "position": 4,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#samtools-sort.cwl/marko_zecevic_topmed_alignment_samtools_sort_0/threads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Number of threads",
                    "default": 1
                },
                {
                    "id": "#samtools-sort.cwl/marko_zecevic_topmed_alignment_samtools_sort_0/ram_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum amount of RAM",
                    "default": 7000
                },
                {
                    "id": "#samtools-sort.cwl/marko_zecevic_topmed_alignment_samtools_sort_0/cores_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum number of cores",
                    "default": 2
                }
            ],
            "outputs": [
                {
                    "id": "#samtools-sort.cwl/marko_zecevic_topmed_alignment_samtools_sort_0/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.sorted.bam",
                        "outputEval": "$(inheritMetadata(self, inputs.input_file))"
                    }
                }
            ],
            "label": "SAMtools Sort",
            "arguments": [
                {
                    "position": 1,
                    "prefix": "--threads",
                    "shellQuote": false,
                    "valueFrom": "$(inputs.threads)"
                },
                {
                    "position": 3,
                    "prefix": "-o",
                    "shellQuote": false,
                    "valueFrom": "${\n    var input_filename = inputs.input_file.path.split('/').pop()\n    return input_filename.slice(0,input_filename.lastIndexOf('.')) + '.sorted.bam'\n}"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": "$(inputs.ram_min)",
                    "coresMin": "$(inputs.cores_min)"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "statgen/alignment:1.0.0"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.reference)"
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file))\n        file['metadata'] = metadata;\n    else {\n        for (var key in metadata) {\n            file['metadata'][key] = metadata[key];\n        }\n    }\n    return file\n};\n\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n        }\n    }\n    return o1;\n};"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comAWSInstanceType",
                    "value": "c5.4xlarge;ebs-gp2;512"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#main",
            "doc": "Checker for the TopMed alignment workflow.",
            "label": "TOPMed Alignment - checker",
            "inputs": [
                {
                    "id": "#main/reference_genome",
                    "type": "File",
                    "label": "Reference for output CRAM compressing",
                    "https://sevenbridges.comfileTypes": "FA, FASTA",
                    "https://sevenbridges.comx": -400,
                    "https://sevenbridges.comy": -215
                },
                {
                    "id": "#main/input_file",
                    "type": "File",
                    "label": "Input CRAM file",
                    "https://sevenbridges.comfileTypes": "CRAM",
                    "https://sevenbridges.comx": -541,
                    "https://sevenbridges.comy": -111
                },
                {
                    "id": "#main/bwa_index",
                    "type": "File",
                    "label": "BWA index",
                    "https://sevenbridges.comfileTypes": "TAR",
                    "https://sevenbridges.comx": -366,
                    "https://sevenbridges.comy": 164.0259246826172
                },
                {
                    "id": "#main/dbsnp",
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "dbSNP VCF file",
                    "https://sevenbridges.comfileTypes": "VCF, VCF.GZ",
                    "https://sevenbridges.comx": -486,
                    "https://sevenbridges.comy": 112
                },
                {
                    "id": "#main/expected_md5",
                    "type": "string",
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/decomp_ref",
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "Reference for input CRAM decompressing",
                    "https://sevenbridges.comfileTypes": "FASTA, FA",
                    "https://sevenbridges.comx": -582,
                    "https://sevenbridges.comy": 6
                }
            ],
            "outputs": [
                {
                    "id": "#main/aligned_out",
                    "outputSource": "#main/topmed_alignment/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "CRAM output",
                    "https://sevenbridges.comfileTypes": "CRAM",
                    "https://sevenbridges.comx": 29,
                    "https://sevenbridges.comy": 125
                },
                {
                    "id": "#main/stdout",
                    "outputSource": "#main/alignment_validation/stdout",
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://sevenbridges.comx": 189,
                    "https://sevenbridges.comy": -201
                },
                {
                    "id": "#main/stderr",
                    "outputSource": "#main/alignment_validation/stderr",
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://sevenbridges.comx": 179,
                    "https://sevenbridges.comy": 48
                }
            ],
            "steps": [
                {
                    "id": "#main/topmed_alignment",
                    "in": [
                        {
                            "id": "#main/topmed_alignment/input_file",
                            "source": "#main/input_file"
                        },
                        {
                            "id": "#main/topmed_alignment/bwa_index",
                            "source": "#main/bwa_index"
                        },
                        {
                            "id": "#main/topmed_alignment/reference_genome",
                            "source": "#main/reference_genome"
                        },
                        {
                            "id": "#main/topmed_alignment/dbsnp",
                            "source": "#main/dbsnp"
                        },
                        {
                            "id": "#main/topmed_alignment/decomp_ref",
                            "source": "#main/decomp_ref"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/topmed_alignment/output"
                        }
                    ],
                    "run": "#topmed-alignment.cwl",
                    "label": "TOPMed Alignment",
                    "https://sevenbridges.comx": -175,
                    "https://sevenbridges.comy": -16
                },
                {
                    "id": "#main/alignment_validation",
                    "in": [
                        {
                            "id": "#main/alignment_validation/cram",
                            "source": "#main/topmed_alignment/output"
                        },
                        {
                            "id": "#main/alignment_validation/expected_md5",
                            "source": "#main/expected_md5"
                        },
                        {
                            "id": "#main/alignment_validation/reference",
                            "source": "#main/reference_genome"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/alignment_validation/stdout"
                        },
                        {
                            "id": "#main/alignment_validation/stderr"
                        }
                    ],
                    "run": "#alignment-validation.cwl",
                    "label": "Validation",
                    "https://sevenbridges.comx": 30,
                    "https://sevenbridges.comy": -107
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comAWSInstanceType",
                    "value": "c4.4xlarge;ebs-gp2;256"
                }
            ],
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "http://purl.org/dc/terms/creator": {
                "foaf:mbox": "mailto:support@sbgenomics.com",
                "foaf:name": "Seven Bridges"
            },
            "https://sevenbridges.comwrapperAuthor": "Marko Zecevic (marko.zecevic@sbgenomics.com)"
        },
        {
            "class": "Workflow",
            "id": "#topmed-alignment.cwl",
            "doc": "A CWL wrapper of the TopMed alignment workflow described here: https://github.com/statgen/docker-alignment Tool Author: Hyun Min Kang (hmkang@umich.edu) and Adrian Tan (atks@umich.edu) Wrapper Author: Marko Zecevic (marko.zecevic@sbgenomics.com)",
            "label": "TOPMed Alignment",
            "inputs": [
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/input_file",
                    "type": "File",
                    "label": "Input CRAM file",
                    "https://sevenbridges.comfileTypes": "CRAM",
                    "https://sevenbridges.comx": -253.4855499267578,
                    "https://sevenbridges.comy": 25.186986923217773
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/bwa_index",
                    "type": "File",
                    "label": "BWA Index",
                    "https://sevenbridges.comfileTypes": "TAR",
                    "https://sevenbridges.comx": 114.04255676269531,
                    "https://sevenbridges.comy": 179.9574432373047
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/reference_genome",
                    "type": "File",
                    "label": "Reference for output CRAM compressing",
                    "https://sevenbridges.comfileTypes": "FA, FASTA",
                    "https://sevenbridges.comx": -106.77165222167969,
                    "https://sevenbridges.comy": -187.8012237548828
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/dbsnp",
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "dbSNP VCF file",
                    "https://sevenbridges.comfileTypes": "VCF, VCF.GZ",
                    "https://sevenbridges.comx": 400,
                    "https://sevenbridges.comy": 222
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/decomp_ref",
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "Reference for input CRAM decompressing",
                    "https://sevenbridges.comfileTypes": "FASTA, FA",
                    "https://sevenbridges.comx": -152.35092163085938,
                    "https://sevenbridges.comy": 139.45030212402344
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/threads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Number of threads"
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/ram_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum amount of RAM"
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/cores_min",
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Minimum number of cores"
                }
            ],
            "outputs": [
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/output",
                    "outputSource": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "Output CRAM file",
                    "https://sevenbridges.comfileTypes": "CRAM",
                    "https://sevenbridges.comx": 861,
                    "https://sevenbridges.comy": -72
                }
            ],
            "steps": [
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align",
                    "in": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/input_file",
                            "source": "#topmed-alignment.cwl/topmed_alignment/input_file"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/decomp_ref",
                            "source": "#topmed-alignment.cwl/topmed_alignment/decomp_ref"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/comp_ref",
                            "source": "#topmed-alignment.cwl/topmed_alignment/reference_genome"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/threads",
                            "source": "#topmed-alignment.cwl/topmed_alignment/threads",
                            "default": 1
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/ram_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/ram_min",
                            "default": 7500
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/cores_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/cores_min",
                            "default": 8
                        }
                    ],
                    "out": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/fastq"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/list"
                        }
                    ],
                    "run": "#pre-align.cwl",
                    "label": "Pre-align 1.0",
                    "https://sevenbridges.comx": 130.828125,
                    "https://sevenbridges.comy": 0
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/topmed_align",
                    "in": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_align/reference",
                            "source": "#topmed-alignment.cwl/topmed_alignment/bwa_index"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_align/fastq",
                            "source": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/fastq"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_align/list",
                            "source": "#topmed-alignment.cwl/topmed_alignment/topmed_pre_align/list"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_align/ram_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/ram_min",
                            "default": 14000
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_align/cores_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/cores_min",
                            "default": 8
                        }
                    ],
                    "out": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_align/cram"
                        }
                    ],
                    "run": "#align.cwl",
                    "label": "Align 1.0",
                    "scatter": [
                        "#topmed-alignment.cwl/topmed_alignment/topmed_align/fastq"
                    ],
                    "scatterMethod": "dotproduct",
                    "https://sevenbridges.comx": 307,
                    "https://sevenbridges.comy": 63.021278381347656
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/samtools_sort",
                    "in": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/samtools_sort/reference",
                            "source": "#topmed-alignment.cwl/topmed_alignment/reference_genome"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/samtools_sort/input_file",
                            "source": "#topmed-alignment.cwl/topmed_alignment/topmed_align/cram"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/samtools_sort/threads",
                            "source": "#topmed-alignment.cwl/topmed_alignment/threads",
                            "default": 1
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/samtools_sort/ram_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/ram_min",
                            "default": 7000
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/samtools_sort/cores_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/cores_min",
                            "default": 2
                        }
                    ],
                    "out": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/samtools_sort/output"
                        }
                    ],
                    "run": "#samtools-sort.cwl",
                    "label": "SAMtools Sort",
                    "scatter": [
                        "#topmed-alignment.cwl/topmed_alignment/samtools_sort/input_file"
                    ],
                    "scatterMethod": "dotproduct",
                    "https://sevenbridges.comx": 482.89361572265625,
                    "https://sevenbridges.comy": -1.872340440750122
                },
                {
                    "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align",
                    "in": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/reference",
                            "source": "#topmed-alignment.cwl/topmed_alignment/reference_genome"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/dbsnp",
                            "source": "#topmed-alignment.cwl/topmed_alignment/dbsnp"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/alignment_files",
                            "source": "#topmed-alignment.cwl/topmed_alignment/samtools_sort/output"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/input_cram",
                            "source": "#topmed-alignment.cwl/topmed_alignment/input_file"
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/threads",
                            "source": "#topmed-alignment.cwl/topmed_alignment/threads",
                            "default": 1
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/ram_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/ram_min",
                            "default": 7500
                        },
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/cores_min",
                            "source": "#topmed-alignment.cwl/topmed_alignment/cores_min",
                            "default": 8
                        }
                    ],
                    "out": [
                        {
                            "id": "#topmed-alignment.cwl/topmed_alignment/topmed_post_align/output"
                        }
                    ],
                    "run": "#post-align.cwl",
                    "label": "Post-align",
                    "https://sevenbridges.comx": 668.5106811523438,
                    "https://sevenbridges.comy": 8.829793930053711
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": "8"
                }
            ],
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "http://purl.org/dc/terms/creator": {
                "foaf:mbox": "mailto:support@sbgenomics.com",
                "foaf:name": "Seven Bridges"
            },
            "https://sevenbridges.comcategories": [
                "Alignment"
            ],
            "https://sevenbridges.comlinks": [
                {
                    "id": "#docker-alignment",
                    "label": "github"
                }
            ],
            "https://sevenbridges.comtoolAuthor": "Hyun Min Kang (hmkang@umich.edu) and Adrian Tan (atks@umich.edu)",
            "https://sevenbridges.comwrapperAuthor": "Marko Zecevic (marko.zecevic@sbgenomics.com)"
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "sbg": "https://sevenbridges.com"
    }
}
